const { GObject, St, Gio, GLib } = imports.gi;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;

let BOOSTED = false;

var VolumeBooster = GObject.registerClass(
  {
    GTypeName: "VolumeBooster",
    Name: "VolumeBooster",
  },
  class VolumeBooster extends PanelMenu.Button {
    _init() {
      super._init(1, "VolumeBooster", false);

      let box = new St.BoxLayout({ style_class: "panel-status-menu-box" });

      this.icon = new St.Icon({
        icon_name: "emblem-music-symbolic",
        style_class: "custom-icon",
      });
      box.add(this.icon);
      this.actor.add_child(box);
      this._buildMenu();
    }

    _buildMenu() {
      let that = this;

      that.customMenuItem = new PopupMenu.PopupSwitchMenuItem(
        _("Boost Volume (x2)"),
        BOOSTED,
        { reactive: true }
      );

      //start

      let [res_, pid_, in_fd_, out_fd_, err_fd_] = GLib.spawn_async_with_pipes(
        null,
        ["pactl", "list", "short", "sinks"],
        null,
        GLib.SpawnFlags.SEARCH_PATH,
        null
      );

      let out_reader_ = new Gio.DataInputStream({
        base_stream: new Gio.UnixInputStream({ fd: out_fd_ }),
      });

      // for (let eee = 0; eee < 1; eee++) {
      //   out_reader_.read_line(null);
      // }
      let [out_, size_] = out_reader_.read_line(null);

      this.sink_index = out_.toString().charAt(0);

      let [res, pid, in_fd, out_fd, err_fd] = GLib.spawn_async_with_pipes(
        null,
        ["pactl", "list", "sinks"],
        null,
        GLib.SpawnFlags.SEARCH_PATH,
        null
      );

      let out_reader = new Gio.DataInputStream({
        base_stream: new Gio.UnixInputStream({ fd: out_fd }),
      });

      for (let ee = 0; ee < 9; ee++) {
        out_reader.read_line(null);
      }
      let [out, size] = out_reader.read_line(null);

      let ss = out.toString();

      ss = ss.split(" ");

      out = ss[4];
      out = out.substring(0, out.length - 1);

      if (out_fd == null) {
      } else {
        if (out > 160) {
          that.customMenuItem._switch.state = true;

          that.icon.add_style_class_name("boosted");
        } else {
          that.customMenuItem._switch.state = false;

          that.icon.remove_style_class_name("boosted");
        }
      }

      that.customMenuItem.connect("toggled", that._onToggle.bind(that));

      //end

      that.menu.addMenuItem(that.customMenuItem);
    }

    _onToggle() {
      BOOSTED = this.customMenuItem.state;
      if (!BOOSTED) {
        Util.spawn(["pactl", "--", "set-sink-volume", this.sink_index, "150%"]);
        this.icon.remove_style_class_name("boosted");
      } else {
        Util.spawn(["pactl", "--", "set-sink-volume", this.sink_index, "200%"]);
        this.icon.add_style_class_name("boosted");
      }
    }
  }
);
